#include <iostream>
#include <string>
using namespace std;

template <class T>
class queue {
public:
    queue() : p {0}, u {-1}
    {
    }

    void push(T v)
    {
        q[++u] = v;
    }
    void pop()
    {
        ++p;
    }

    /// functii de informare

    bool empty() const
    {
        return p > u;
    }
    int size() const
    {
        return u - p + 1;
    }

    T front() const
    {
        return q[p];
    }

    T back() const
    {
        return q[u];
    }
private:
    int p, u;
    T q[1000];
};

int main()
{
    queue<int> q;
    q.push(10);
    q.push(20);
    q.push(30);
    q.push(40);

    while (!q.empty())
    {
        cout << q.front() << ' ';
        q.pop();
    };


    cout << '\n';
    queue<string> q1;
    q1.push("Ion");
    q1.push("Ana");
    q1.push("Nicu");
    while (!q1.empty())
    {
        cout << q1.front() << ' ';
        q1.pop();
    }
}
