#include <iostream>
#include <string>
using namespace std;

template <class T>
class stack {
public:
    stack() : vf {-1}
    {
    }
    /// functii obligatorii
    void push(T val)
    {
        st[++vf] = val;
    }

    void pop()
    {
        vf--;
    }

    /// functii de informare

    T top() const
    {
        return st[vf];
    }

    bool empty() const
    {
        return vf < 0;
    }

    int size() const
    {
        return vf + 1;
    }

private:
    int vf;   /// pozitia elementului din varful stivei
    T st[1000];

};


int main()
{
    stack<int> s1;
    s1.push(10);
    s1.push(20);
    s1.push(30);
    s1.push(40);
    s1.push(50);

    while (!s1.empty())
    {
        cout << s1.top() << '\n';
        s1.pop();
    }

    cout << "==================\n";
    stack<char> s2;
    s2.push('A');
    s2.push('B');
    s2.push('C');
    s2.push('D');
    s2.push('E');

    while (!s2.empty())
    {
        cout << s2.top() << '\n';
        s2.pop();
    }

}
